// VCSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCSample.h"
#include "VCSampleDlg.h"
#include "ConaitoObject.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg dialog

CVCSampleDlg::CVCSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCSampleDlg)
	m_bBusyStatus = FALSE;
	m_bUnavailableStatus = FALSE;
	m_bSpkMute = FALSE;
	m_bMicMute = FALSE;
	m_sSendText = _T("");
	m_nListenPort = 33550;
	m_sProxyServerIP = _T("");
	m_nProxyServerPort = 32444;
	m_sMyUniqueID = _T("");
	m_sToUniqueID = _T("");
	m_sAddConfUniqueId = _T("");
	m_sSendMsgToServer = _T("");
	m_sSendWhisper = _T("");
	m_sSendWhisperUniqueId = _T("");
	m_sMsgDirectIP = _T("");
	m_sMsgDirectPort = 33550;
	m_sMsgDirectMsg = _T("");
	m_sMsgViaProxyUniqueId = _T("");
	m_sMsgViaProxyText = _T("");
	m_sDirectMsgFromUniqueId = _T("");
	m_sMsgViaProxyFromUniqueID = _T("");
	m_sMsgViaProxyToUniqueID = _T("");
	m_sMsgViaProxyIP = _T("");
	m_sMsgViaProxyPort = 32444;
	m_bMicBoost = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pConaitoObject = new CConaitoObject;
}

void CVCSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCSampleDlg)
	DDX_Control(pDX, IDC_LIST_SERVER_MSG_RECEIVE2, m_UniqueIDList);
	DDX_Control(pDX, IDC_LIST_RECEIVE_WHISPER, m_ReceiveWhisperList);
	DDX_Control(pDX, IDC_LIST_SERVER_MSG_RECEIVE, m_ListMsgFromServerReceive);
	DDX_Control(pDX, IDC_COMBO_IP, m_IPComboBox);
	DDX_Control(pDX, IDC_LIST_TEXT, m_ReceiveTxtListBox);
	DDX_Control(pDX, IDC_SLIDER_MICVOL, m_MicSlider);
	DDX_Control(pDX, IDC_SLIDER_SPKVOL, m_SpkSlider);
	DDX_Check(pDX, IDC_CHECK_BUSY, m_bBusyStatus);
	DDX_Check(pDX, IDC_CHECK_UNAVAILABLE, m_bUnavailableStatus);
	DDX_Check(pDX, IDC_CHECK_SPKMUTE, m_bSpkMute);
	DDX_Check(pDX, IDC_CHECK_MICMUTE, m_bMicMute);
	DDX_Text(pDX, IDC_EDIT_TXT, m_sSendText);
	DDX_Text(pDX, IDC_EDIT_LISTEN_PORT, m_nListenPort);
	DDX_Text(pDX, IDC_EDIT_PROXY_IP, m_sProxyServerIP);
	DDX_Text(pDX, IDC_EDIT_REMOTE_PROXY_PORT, m_nProxyServerPort);
	DDX_Text(pDX, IDC_EDIT_PROXY_UNIQUEID, m_sMyUniqueID);
	DDX_CBString(pDX, IDC_COMBO_IP, m_sToUniqueID);
	DDX_CBString(pDX, IDC_COMBO_ADD_CONF, m_sAddConfUniqueId);
	DDX_Text(pDX, IDC_EDIT_SERVER_MSG_SEND, m_sSendMsgToServer);
	DDX_Text(pDX, IDC_EDIT_SEND_MSG_WHISPER, m_sSendWhisper);
	DDX_Text(pDX, IDC_EDIT_SEND_WHISPER_UNIQUEID, m_sSendWhisperUniqueId);
	DDX_Text(pDX, IDC_EDIT_MSG_DIRECT_IP, m_sMsgDirectIP);
	DDX_Text(pDX, IDC_EDIT_MSG_DIRECT_PORT, m_sMsgDirectPort);
	DDX_Text(pDX, IDC_EDIT_MSG_DIRECT_MSG, m_sMsgDirectMsg);
	DDX_Text(pDX, IDC_EDIT_MSG_PROXY_UNIQUEID, m_sMsgViaProxyUniqueId);
	DDX_Text(pDX, IDC_EDIT_MSG_PROXY_MSG, m_sMsgViaProxyText);
	DDX_Text(pDX, IDC_EDIT_MSG_DIRECT_FROMUNIQUEID, m_sDirectMsgFromUniqueId);
	DDX_Text(pDX, IDC_EDIT_MSG_VIAPROXY_FROMUNIQUEID, m_sMsgViaProxyFromUniqueID);
	DDX_Text(pDX, IDC_EDIT_MSG_VIAPROXY_TOUNIQUEID, m_sMsgViaProxyToUniqueID);
	DDX_Text(pDX, IDC_EDIT_MSG_VIA_PROXY_IP, m_sMsgViaProxyIP);
	DDX_Text(pDX, IDC_EDIT_MSG_VIA_PROXY_PORT, m_sMsgViaProxyPort);
	DDX_Check(pDX, IDC_CHECK_MIC_GAIN, m_bMicBoost);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVCSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_ONLINE, OnButtonOnline)
	ON_BN_CLICKED(IDC_BUTTON_OFFLINE, OnButtonOffline)
	ON_BN_CLICKED(IDC_BUTTON_MAKECALL, OnButtonMakecall)
	ON_BN_CLICKED(IDC_BUTTON_ENDCALL, OnButtonEndcall)
	ON_BN_CLICKED(IDC_CHECK_UNAVAILABLE, OnCheckUnavailable)
	ON_BN_CLICKED(IDC_CHECK_BUSY, OnCheckBusy)
	ON_BN_CLICKED(IDC_CHECK_MICMUTE, OnCheckMicmute)
	ON_BN_CLICKED(IDC_CHECK_SPKMUTE, OnCheckSpkmute)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON_SENDTXT, OnButtonSendtxt)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_REGTOPROXY, OnButtonRegtoproxy)
	ON_BN_CLICKED(IDC_BUTTON_UNREGTOPROXY, OnButtonUnregtoproxy)
	ON_BN_CLICKED(IDC_BUTTON_ADD_CONF, OnButtonAddConf)
	ON_BN_CLICKED(IDC_BUTTON_SENDSERVERMSG, OnButtonSendservermsg)
	ON_BN_CLICKED(IDC_BUTTON_SEND_WHISPER, OnButtonSendWhisper)
	ON_BN_CLICKED(IDC_BUTTON_SEND_MSG_DIRECT, OnButtonSendMsgDirect)
	ON_BN_CLICKED(IDC_BUTTON_SEND_MSG_PROXY, OnButtonSendMsgProxy)
	ON_BN_CLICKED(IDC_BUTTON_GET_UNIQUEIDSLIST, OnButtonGetUniqueidslist)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_CHECK_MIC_GAIN, OnCheckMicGain)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCSampleDlg message handlers

BOOL CVCSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	m_SpkSlider.SetRange(0,10);
	m_MicSlider.SetRange(0,10);
	
	CWnd* pTxRxIconWnd = GetDlgItem(IDC_STATIC_RED);
	pTxRxIconWnd->ShowWindow(SW_HIDE);

	pTxRxIconWnd = GetDlgItem(IDC_STATIC_GREEN);
	pTxRxIconWnd->ShowWindow(SW_HIDE);

	pTxRxIconWnd = GetDlgItem(IDC_STATIC_GB);
	pTxRxIconWnd->ShowWindow(SW_SHOW);

	pTxRxIconWnd = GetDlgItem(IDC_STATIC_RB);
	pTxRxIconWnd->ShowWindow(SW_SHOW);

	
	// Mic Boost Functionality
	
	int nValue = m_pConaitoObject->GetMicBoost();

	if(nValue == 1)
	{
		m_bMicBoost = TRUE;
		UpdateData(FALSE);
	}
	else if(nValue == 0)
	{
		m_bMicBoost = FALSE;
		UpdateData(FALSE);
	}
	else if(nValue == -1)
	{
		// ERROR in retrieving Mic Boost OR Mic Boost does not exist
	}

	SetTimer(0, 500, NULL);
		
	return TRUE;
}


void CVCSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


HCURSOR CVCSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVCSampleDlg::OnDestroy() 
{
	delete m_pConaitoObject;
	
	CDialog::OnDestroy();
}


void CVCSampleDlg::OnButtonOnline() 
{
	UpdateData();
	
	m_pConaitoObject->SetLicenceKey("EVALUATION");

	if(!m_pConaitoObject->Initialize(m_nListenPort))
	{
		m_pConaitoObject->ErrorMessage();
		return;
	}

	m_pConaitoObject->SetMicVolume(255);
	m_pConaitoObject->SetSpkVolume(255);
		
	int nVol = m_pConaitoObject->GetMicVolume();
		
	if(nVol == -1)
	{
		m_pConaitoObject->ErrorMessage();
		return;
	}

	m_MicSlider.SetPos(nVol/25);

	nVol = m_pConaitoObject->GetSpkVolume();
	
	if(nVol == -1)
	{
		m_pConaitoObject->ErrorMessage();
		return;
	}

	m_SpkSlider.SetPos(nVol/25);
	
	

}

void CVCSampleDlg::OnButtonOffline() 
{
	m_pConaitoObject->UnInitialize();
}

void CVCSampleDlg::OnButtonMakecall() 
{
	UpdateData();
	
	if(!m_pConaitoObject->Connect(m_sToUniqueID, 20)) //TimeOut in seconds
	{
		m_pConaitoObject->ErrorMessage();
	}

	m_IPComboBox.AddString(m_sToUniqueID);
}

void CVCSampleDlg::OnButtonEndcall() 
{
	if(!m_pConaitoObject->Disconnect())
	{
		m_pConaitoObject->ErrorMessage();
	}

	GetDlgItem(IDC_STATIC_CALLSTATUS)->SetWindowText("");

}

void CVCSampleDlg::OnCheckUnavailable() 
{
	UpdateData();
	
	if(m_bUnavailableStatus)
	{
		m_pConaitoObject->EnableNotAvailableState();
	}
	else
	{
		m_pConaitoObject->DisableNotAvailableState();
	}
}

void CVCSampleDlg::OnCheckBusy() 
{
	UpdateData();
	
	if(m_bBusyStatus)
	{
		m_pConaitoObject->EnableBusyState();
	}
	else
	{
		m_pConaitoObject->DisableBusyState();
	}
}

void CVCSampleDlg::OnCheckMicmute() 
{
	UpdateData();
	m_pConaitoObject->MuteMic(m_bMicMute);
}

void CVCSampleDlg::OnCheckSpkmute() 
{
	UpdateData();
	m_pConaitoObject->MuteSpk(m_bSpkMute);
}

void CVCSampleDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if((CSliderCtrl*)pScrollBar == &m_SpkSlider)
	{
		if(TB_THUMBTRACK)
		{
			/***************************************************************
			SetSpkVolume method requires Volume value from 0 to 255 range    
			but the slider range is 0 to 10, so we multiply the slider value 
			to 25 to get the required value to pass to SetSpkVolume method   

							For more detail, please see the method details document
			*****************************************************************/
			
			m_pConaitoObject->SetSpkVolume(m_SpkSlider.GetPos()	* 25);
		}

	}
	
	
	
	if((CSliderCtrl*)pScrollBar == &m_MicSlider)
	{
		if(TB_THUMBTRACK)
		{
			/***************************************************************
			SetMicVolume method requires Volume value from 0 to 255 range    
			but the slider range is 0 to 10, so we multiply the slider value 
			to 25 to get the required value to pass to SetMicVolume method   

							For more detail, please see the method details document
			*****************************************************************/
			
			m_pConaitoObject->SetMicVolume(m_MicSlider.GetPos()	* 25);
		}

	}
	
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CVCSampleDlg::OnButtonSendtxt() 
{
	UpdateData();
	
	if(!m_pConaitoObject->SendTxtMsgToAllInConversation(m_sSendText))
	{
		m_pConaitoObject->ErrorMessage();
	}
	else
	{
		m_ReceiveTxtListBox.AddString("You: " + m_sSendText);
		m_sSendText = _T("");
		UpdateData(FALSE);
	}
}

void CVCSampleDlg::OnTimer(UINT nIDEvent) 
{
	if(m_pConaitoObject->GetOutBoundDataRate() == 0)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_GREEN);
		pWnd->ShowWindow(SW_HIDE);

		pWnd = GetDlgItem(IDC_STATIC_GB);
		pWnd->ShowWindow(SW_SHOW);
	}
	else
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_GREEN);
		pWnd->ShowWindow(SW_SHOW);

		pWnd = GetDlgItem(IDC_STATIC_GB);
		pWnd->ShowWindow(SW_HIDE);
	}
	

	if(m_pConaitoObject->GetInBoundDataRate() == 0)
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_RED);
		pWnd->ShowWindow(SW_HIDE);

		pWnd = GetDlgItem(IDC_STATIC_RB);
		pWnd->ShowWindow(SW_SHOW);
	}
	else
	{
		CWnd* pWnd = GetDlgItem(IDC_STATIC_RED);
		pWnd->ShowWindow(SW_SHOW);

		pWnd = GetDlgItem(IDC_STATIC_RB);
		pWnd->ShowWindow(SW_HIDE);
	}

	CDialog::OnTimer(nIDEvent);
}

void CVCSampleDlg::OnButtonRegtoproxy() 
{
	UpdateData();
	
	if(!m_pConaitoObject->RegisterToProxy(m_sMyUniqueID, m_sProxyServerIP, m_nProxyServerPort, "sParamValue1", "sParamValue2", "sParamValue3", "sParamValue4", "sParamValue5", "192.168.9.10", 33600, 6))
	{
		m_pConaitoObject->ErrorMessage();
	}
	else
	{
		DWORD dwReturnedValue = m_pConaitoObject->GetProxyParamValueReturned();
		if(dwReturnedValue == 1001)
		{
			if(!m_pConaitoObject->RegisterToProxyDone())
			{
				m_pConaitoObject->ErrorMessage();
			}
						
			MessageBox("Successfully Registered to Proxy Server", "Proxy Server");
		}
	}
}

void CVCSampleDlg::OnButtonUnregtoproxy() 
{
	if(!m_pConaitoObject->UnRegisterToProxy())
	{
		m_pConaitoObject->ErrorMessage();
	}
}


void CVCSampleDlg::OnButtonAddConf() 
{
	UpdateData();
	
	if(!m_pConaitoObject->AddConf(m_sAddConfUniqueId, 10))
	{
		m_pConaitoObject->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonSendservermsg() 
{
	UpdateData();
	
	if(!m_pConaitoObject->SendTxtMsgToServer(m_sSendMsgToServer))
	{
		m_pConaitoObject->ErrorMessage();
	}

}

void CVCSampleDlg::OnButtonSendWhisper() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	
	if(!m_pConaitoObject->SendWhisper(m_sSendWhisperUniqueId, m_sSendWhisper))
	{
		m_pConaitoObject->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonSendMsgDirect() 
{
	UpdateData();
	
	if(!m_pConaitoObject->SendTxtMsgDirect(m_sDirectMsgFromUniqueId, m_sMsgDirectIP, m_sMsgDirectPort, m_sMsgDirectMsg))
	{
		m_pConaitoObject->ErrorMessage();
	}
}

void CVCSampleDlg::OnButtonSendMsgProxy() 
{

	UpdateData();
	
	if(!m_pConaitoObject->SendTxtMsgThroughProxy(m_sMsgViaProxyFromUniqueID, m_sMsgViaProxyToUniqueID,m_sMsgViaProxyIP, m_sMsgViaProxyPort, m_sMsgViaProxyText))
	{
		m_pConaitoObject->ErrorMessage();
	}

}

void CVCSampleDlg::OnButtonGetUniqueidslist() 
{
	m_UniqueIDList.ResetContent();
	CString sTextMsg = "";
		
	for(int nIndex = 0;; nIndex++)
	{
		sTextMsg = m_pConaitoObject->GetConversationUniqueIdAt(nIndex);
		
		if(sTextMsg == "") break;

		m_UniqueIDList.AddString(sTextMsg);
	}

}

void CVCSampleDlg::OnCheckMicGain() 
{
	UpdateData();
	
	if(m_bMicBoost)
	{
		m_pConaitoObject->EnableMicBoost();
	}
	else
	{
		m_pConaitoObject->DisableMicBoost();

	}
}
